Index: /collectparties.sh
===================================================================
--- /collectparties.sh	(revision 47)
+++ /collectparties.sh	(revision 48)
@@ -7,5 +7,5 @@
 rm -rf collectedparties
 mkdir collectedparties
-VERSION=2.1.2
+VERSION=2.1.3
 
 cp "exampleparties/anac2019/agentgg/target/agentgg-${VERSION}-jar-with-dependencies.jar" collectedparties
Index: /logconverter/src/main/java/geniusweb/logconverter/Convert.java
===================================================================
--- /logconverter/src/main/java/geniusweb/logconverter/Convert.java	(revision 48)
+++ /logconverter/src/main/java/geniusweb/logconverter/Convert.java	(revision 48)
@@ -0,0 +1,262 @@
+package geniusweb.logconverter;
+
+import java.io.BufferedWriter;
+import java.io.File;
+import java.io.FileWriter;
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.logging.Level;
+
+import org.apache.commons.cli.BasicParser;
+import org.apache.commons.cli.CommandLine;
+import org.apache.commons.cli.CommandLineParser;
+import org.apache.commons.cli.HelpFormatter;
+import org.apache.commons.cli.Option;
+import org.apache.commons.cli.Options;
+import org.apache.commons.cli.ParseException;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.PartyId;
+import geniusweb.protocol.NegoState;
+import geniusweb.protocol.session.SessionResult;
+import tudelft.utilities.logging.Reporter;
+
+/**
+ * Utility class with command line options and main program. Converts a
+ * NegoState into a file (CSV, JSON) with utilities for each session. Contacts
+ * the actual profileservers/profile files to do so.
+ */
+public class Convert {
+	private static final String JSON = ".json";
+	private final static ObjectMapper jackson = new ObjectMapper();
+	private final Reporter reporter;
+	private final File source;
+	private final File output;
+	private final Format format;
+
+	/**
+	 * How {@link SessionResultWithUtils} is written to the output
+	 */
+	enum Format {
+		CSV, // for each party write sessionnr, partyname, profilename, final
+				// util
+		JSON // jackson serializes it
+	};
+
+	/**
+	 * @param sourcedir a directory or file to convert. If directory, converts
+	 *                  all json files in the dir.
+	 * @param level     the debug {@link Level}. Debug messages at or above this
+	 *                  level go to stderr.
+	 * @param outputf   the output file or directory to write results to. null=
+	 *                  write to stdout. If output=file then input must be also
+	 *                  a single file.
+	 * @throws IOException
+	 * @throws JsonMappingException
+	 * @throws JsonParseException
+	 */
+	public Convert(File source, Level level, File outputf, Format format,
+			Reporter reporter)
+			throws JsonParseException, JsonMappingException, IOException {
+		this.source = source;
+		this.format = format;
+		this.output = outputf;
+		this.reporter = reporter;
+		if (outputf != null) {
+			if (outputf.exists()) {
+				if (!outputf.isDirectory())
+					throw new IOException("Output " + outputf
+							+ " exists but is not a directory");
+				if (!outputf.canWrite())
+					throw new IOException("" + outputf + " is write protected");
+			}
+			if (source.isDirectory() && !outputf.isDirectory())
+				throw new IOException(
+						"Source is a directory, output must also be a directory but got  "
+								+ output);
+		}
+		if (source.isDirectory()) {
+			File filesList[] = source.listFiles();
+			for (File file : filesList) {
+				if (file.getName().endsWith(JSON)) {
+					output(file, convertFile(file));
+				}
+			}
+		} else {
+			output(source, convertFile(source));
+		}
+
+	}
+
+	/**
+	 * Writes converted file to the {@link #output}, or stdout if null. The
+	 * destination file will match the source file. Destination file must not
+	 * exist.
+	 * 
+	 * If {@link #output} is a dir , the name of the source file is used for the
+	 * destination file. The extension is replaced with {@link #format}.
+	 * 
+	 * @param src the source {@link File}. May be used to generate output
+	 *            filename.
+	 * @param res the result to write to the output.
+	 */
+	private void output(File src, List<SessionResultWithUtils> res) {
+		String text = "";
+		switch (format) {
+		case CSV:
+			text = "session,party,profile,utility\n";
+			long sessionnr = 0;
+			for (SessionResultWithUtils r : res) {
+				for (PartyId party : r.getParticipants().keySet()) {
+					text = text + "" + sessionnr + ","
+							+ r.getParticipants().get(party).getParty()
+									.getPartyRef().getURI()
+							+ ","
+							+ r.getParticipants().get(party).getProfile()
+									.getURI()
+							+ "," + r.getUtilities().get(party) + "\n";
+				}
+				sessionnr++;
+			}
+			break;
+		case JSON:
+			try {
+				text = jackson.writeValueAsString(res);
+			} catch (JsonProcessingException e) {
+				reporter.log(Level.SEVERE,
+						fullMessage("Failed to convert result to json:", e));
+			}
+		}
+
+		if (output == null) {
+			System.out.println(text);
+		} else {
+			File outfile;
+			if (output.exists()) {
+				// must be dir
+				String destfilename = src.getName();
+				if (destfilename.endsWith(JSON)) {
+					destfilename = destfilename.substring(0,
+							destfilename.length() - 4) + format;
+				}
+				outfile = new File(output.getAbsolutePath(), destfilename);
+
+			} else {
+				// we assume output is just the file to write to.
+				outfile = output;
+			}
+			try {
+				if (outfile.exists())
+					throw new IOException(
+							"destination file already exists:" + outfile);
+				BufferedWriter writer = new BufferedWriter(
+						new FileWriter(outfile));
+				writer.write(text);
+				writer.close();
+			} catch (IOException e) {
+				reporter.log(Level.SEVERE, fullMessage(
+						"Failed to write result to file " + outfile, e));
+			}
+		}
+
+	}
+
+	/** @return all messages from stacktraces */
+	private String fullMessage(String msg, Throwable e) {
+		while (e != null) {
+			msg = msg + ":" + e.getMessage();
+			e = e.getCause();
+		}
+		return msg;
+	}
+
+	private List<SessionResultWithUtils> convertFile(File file)
+			throws JsonParseException, JsonMappingException, IOException {
+		NegoState state = jackson.readValue(file, NegoState.class);
+		List<SessionResultWithUtils> results = new LinkedList<>();
+		for (SessionResult res : state.getResults()) {
+			results.add(SessionResultWithUtils.create(res, reporter));
+		}
+		return results;
+	}
+
+	/**
+	 * 
+	 * @param args first arg must be folder containing .json files containing
+	 *             NegoState objects. All objects are parsed, getResults() is
+	 *             called, and all results are converted to
+	 *             SessionResultWithUtils.
+	 */
+	public static void main(String[] args) {
+
+		CommandLineParser parser = new BasicParser();
+		// use to read Command Line Arguments
+		HelpFormatter formatter = new HelpFormatter(); // // Use to Format
+		CommandLine cmd = null;
+		Options options = getOpts();
+
+		try {
+			cmd = parser.parse(options, args); // it will parse according to the
+												// options and parse option
+												// value
+			String source = cmd.getOptionValue("source");
+			String output = cmd.getOptionValue("output");
+			Level level = Level.parse(cmd.getOptionValue("level", "WARNING"));
+			Format format = Format
+					.valueOf(cmd.getOptionValue("format", "JSON"));
+			new Convert(new File(source), level,
+					output == null ? null : new File(output), format,
+					new StdOutReporter(level));
+		} catch (ParseException e) {
+			System.out.println(e.getMessage());
+			formatter.printHelp("Convert", options);
+		} catch (IOException e) {
+			e.printStackTrace();
+		}
+	}
+
+	private static Options getOpts() {
+		Options options = new Options(); // Options Arguments which are
+		// Acceptable By Program.
+		Option source = new Option("s", "source", true,
+				"source file path. If dir, all json files in the dir are converted");
+		source.setRequired(true);
+		options.addOption(source);
+		Option destination = new Option("o", "output", true,
+				"Destination file/dir (must exist and be writable; must be dir if source is dir)");
+		options.addOption(destination);
+		Option debuglevel = new Option("l", "debuglevel", true,
+				"Debug level (WARNING, SEVERE, INFO, FINE, FINEST) ");
+		options.addOption(debuglevel);
+		Option format = new Option("f", "format", true,
+				"output format " + Arrays.toString(Format.values()));
+		options.addOption(format);
+
+		return options;
+	}
+}
+
+class StdOutReporter implements Reporter {
+	private final Level level;
+
+	public StdOutReporter(Level level) {
+		this.level = level;
+	}
+
+	@Override
+	public void log(Level level, String msg) {
+		if (level.intValue() >= this.level.intValue())
+			System.err.println(level + ":" + msg);
+	}
+
+	@Override
+	public void log(Level arg0, String msg, Throwable arg2) {
+		log(arg0, msg);
+	}
+}
Index: /logconverter/src/main/java/geniusweb/logconverter/SessionResultWithUtils.java
===================================================================
--- /logconverter/src/main/java/geniusweb/logconverter/SessionResultWithUtils.java	(revision 48)
+++ /logconverter/src/main/java/geniusweb/logconverter/SessionResultWithUtils.java	(revision 48)
@@ -0,0 +1,166 @@
+package geniusweb.logconverter;
+
+import java.io.IOException;
+import java.math.BigDecimal;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Objects;
+import java.util.logging.Level;
+
+import javax.websocket.DeploymentException;
+
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.actions.PartyId;
+import geniusweb.inform.Agreements;
+import geniusweb.issuevalue.Bid;
+import geniusweb.profile.PartialOrdering;
+import geniusweb.profile.utilityspace.UtilitySpace;
+import geniusweb.profileconnection.ProfileConnectionFactory;
+import geniusweb.profileconnection.ProfileInterface;
+import geniusweb.protocol.session.SessionResult;
+import geniusweb.references.PartyWithProfile;
+import geniusweb.references.ProfileRef;
+import tudelft.utilities.logging.Reporter;
+
+/**
+ * Contains SessionResult including the utilities.
+ */
+public class SessionResultWithUtils extends SessionResult {
+
+	private final Map<PartyId, BigDecimal> utilities;
+	private final static transient Map<ProfileRef, UtilitySpace> profilecache = new HashMap<>();;
+
+	/**
+	 * 
+	 * @param res   a {@link SessionResult}
+	 * @param utils a map of the netto utility (including penalty) by each
+	 *              party. 0 if not known or invalid.
+	 */
+	public SessionResultWithUtils(
+			@JsonProperty("participants") Map<PartyId, PartyWithProfile> participants,
+			@JsonProperty("agreements") Agreements agreements,
+			@JsonProperty("penalties") Map<PartyId, Double> penalties,
+			@JsonProperty("error") Throwable error,
+			@JsonProperty("utilities") Map<PartyId, BigDecimal> utils) {
+		super(participants, agreements, penalties, error);
+		this.utilities = new HashMap<>(utils);
+		List<PartyId> missed = new ArrayList<PartyId>(participants.keySet());
+		missed.removeAll(utils.keySet());
+		if (!missed.isEmpty())
+			throw new IllegalArgumentException(
+					"participants " + missed + " must also get a utility");
+
+	}
+
+	/**
+	 * adds utility values to a standard SessionResult.
+	 * 
+	 * @param res the standard {@link SessionResult}
+	 * @return a {@link SessionResultWithUtils}. The utilities for of the
+	 *         agreement are computed using the profile available in the given
+	 *         {@link SessionResult}. The penalty will be subtracted from this.
+	 *         Notice that the final value thus can be negative.
+	 *         <p>
+	 *         If there is no agreement, the utility of the reservation bid will
+	 *         be used. If there is no reservation bid, utility is 0.
+	 *         <p>
+	 *         If a profile is not a {@link UtilitySpace}, eg the profile is a
+	 *         {@link PartialOrdering} or is unavailable (eg security
+	 *         restrictions or server down), the utility will be set to 0.
+	 *         <p>
+	 *         Any penalty will be subtracted "as is", so if the penalty is 0.2
+	 */
+	public static SessionResultWithUtils create(SessionResult res,
+			Reporter reporter) {
+		Map<PartyId, UtilitySpace> profiles = new HashMap<>();
+		Map<PartyId, BigDecimal> utils = new HashMap<>();
+		Map<PartyId, Bid> agreements = res.getAgreements().getMap();
+
+		for (PartyId party : res.getParticipants().keySet()) {
+			BigDecimal util = BigDecimal.ZERO;
+			UtilitySpace prof = getProfile(
+					res.getParticipants().get(party).getProfile(), reporter);
+			if (prof != null) {
+				Bid bid = agreements.get(party);
+				if (bid == null) {
+					if (prof.getReservationBid() != null)
+						util = prof.getUtility(prof.getReservationBid());
+				} else {
+					// check we have profile to avoid repeated errors
+					util = prof.getUtility(bid);
+					Double penalty = res.getPenalties().get(party);
+					if (penalty != null) {
+						util = util
+								.subtract(new BigDecimal(penalty.toString()));
+					}
+				}
+			}
+			utils.put(party, util);
+		}
+		return new SessionResultWithUtils(res.getParticipants(),
+				res.getAgreements(), res.getPenalties(), res.getError(), utils);
+	}
+
+	/**
+	 * @param profileref
+	 * @param reporter
+	 * @return profile {@link UtilitySpace}, or null if profile can't be
+	 *         fetched. Profiles are cached to avoid repeated fetching.
+	 */
+	private static UtilitySpace getProfile(ProfileRef profileref,
+			Reporter reporter) {
+		UtilitySpace us = null;
+		if (!profilecache.containsKey(profileref)) {
+			try {
+				ProfileInterface interf = ProfileConnectionFactory
+						.create(profileref.getURI(), reporter);
+				us = (UtilitySpace) interf.getProfile();
+			} catch (IOException | DeploymentException e) {
+				e.printStackTrace();
+				reporter.log(Level.WARNING,
+						"Failed to get profile:" + e.getMessage(), e);
+			}
+			profilecache.put(profileref, us);
+		}
+		return profilecache.get(profileref);
+	}
+
+	/**
+	 * 
+	 * @return the netto utility achieved by each party.
+	 */
+	public Map<PartyId, BigDecimal> getUtilities() {
+		return utilities;
+	}
+
+	@Override
+	public String toString() {
+		// not so important as toString is mainly for debugging.
+		return "SessionResultWithUtils[" + super.toString() + "," + utilities
+				+ "]";
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = super.hashCode();
+		result = prime * result + Objects.hash(utilities);
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (!super.equals(obj))
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		SessionResultWithUtils other = (SessionResultWithUtils) obj;
+		return Objects.equals(utilities, other.utilities);
+	}
+
+}
Index: /logconverter/src/test/java/geniusweb/logconverter/ConvertTest.java
===================================================================
--- /logconverter/src/test/java/geniusweb/logconverter/ConvertTest.java	(revision 48)
+++ /logconverter/src/test/java/geniusweb/logconverter/ConvertTest.java	(revision 48)
@@ -0,0 +1,55 @@
+package geniusweb.logconverter;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertTrue;
+
+import java.io.File;
+import java.io.IOException;
+import java.nio.file.Files;
+import java.util.List;
+import java.util.logging.Level;
+
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+
+public class ConvertTest {
+	TestReporter reporter = new TestReporter();
+
+	@Test
+	public void e2esmoketest() {
+		Convert.main(new String[] { "-s",
+				"src/test/resources/APP1646925947841local.json", "-f", "CSV" });
+	}
+
+	@Test
+	public void e2eTest()
+			throws JsonParseException, JsonMappingException, IOException {
+		new Convert(new File("src/test/resources/APP1646925947841local.json"),
+				Level.WARNING, null, Convert.Format.CSV, reporter);
+		assertEquals(null, reporter.getError());
+	}
+
+	@Test
+	public void e2eToFile() throws IOException {
+		File outfile = File.createTempFile("temp", "csv");
+		outfile.delete();
+		new Convert(new File("src/test/resources/APP1646925947841local.json"),
+				Level.WARNING, outfile, Convert.Format.CSV, reporter);
+		assertEquals(null, reporter.getError());
+		List<String> lines = Files.readAllLines(outfile.toPath());
+		assertEquals(37, lines.size());
+		lines.remove(0); // remove header line.
+		int row = 0;
+		for (String line : lines) {
+			String[] cols = line.split(",");
+			Integer session = Integer.valueOf(cols[0]);
+			assertEquals((Integer) (row / 2), session);
+			assertTrue(Double.valueOf(cols[3]) > 0); // all utils valid
+			row++;
+		}
+		outfile.delete();
+	}
+
+}
Index: /logconverter/src/test/java/geniusweb/logconverter/SessionResultWithUtilsTest.java
===================================================================
--- /logconverter/src/test/java/geniusweb/logconverter/SessionResultWithUtilsTest.java	(revision 48)
+++ /logconverter/src/test/java/geniusweb/logconverter/SessionResultWithUtilsTest.java	(revision 48)
@@ -0,0 +1,176 @@
+package geniusweb.logconverter;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.math.BigDecimal;
+import java.net.URISyntaxException;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Map;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.PartyId;
+import geniusweb.inform.Agreements;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.Value;
+import geniusweb.protocol.session.SessionResult;
+import geniusweb.references.Parameters;
+import geniusweb.references.PartyRef;
+import geniusweb.references.PartyWithParameters;
+import geniusweb.references.PartyWithProfile;
+import geniusweb.references.ProfileRef;
+import tudelft.utilities.junit.GeneralTests;
+
+public class SessionResultWithUtilsTest
+		extends GeneralTests<SessionResultWithUtils> {
+
+	private final ObjectMapper jackson = new ObjectMapper();
+	private final RuntimeException error = new RuntimeException("test");
+
+	private final String ISSUE1 = "salary";
+	private final String ISSUE2 = "fte";
+	private String jsonstring = "{\"participants\":{\"party2\":{\"party\":{\"partyref\":\"party2\",\"parameters\":{}},\"profile\":\"file:src/test/resources/profile2.json\"},\"party1\":{\"party\":{\"partyref\":\"party1\",\"parameters\":{}},\"profile\":\"file:src/test/resources/profile1.json\"}},\"agreements\":{\"party2\":{\"issuevalues\":{\"salary\":\"3500\",\"fte\":\"0.8\"}},\"party1\":{\"issuevalues\":{\"salary\":\"3500\",\"fte\":\"0.8\"}}},\"penalties\":{\"party2\":0.002,\"party1\":0.001},\"error\":null,\"utilities\":{\"party2\":0.7,\"party1\":0.8,\"party3\":0.4}}";
+	private Map<PartyId, Double> penalties = new HashMap<>();
+
+	private PartyId PARTY1 = new PartyId("party1");
+	private PartyId PARTY2 = new PartyId("party2");
+	private PartyId PARTY3 = new PartyId("party3");
+
+	private SessionResult result1, result1a, result2, result3;
+	private SessionResultWithUtils reswithutil1, reswithutil1a, reswithutil2;
+
+	@Before
+	public void before() throws URISyntaxException, JsonProcessingException {
+		penalties.put(PARTY1, 0.001d);
+		penalties.put(PARTY2, 0.002d);
+
+		String errorstring = "\"error\":{\"java.lang.RuntimeException\":"
+				+ jackson.writeValueAsString(error) + "}";
+		// System.out.println(errorstring);
+
+		PartyWithParameters party1 = new PartyWithParameters(
+				new PartyRef("party1"), new Parameters());
+		PartyWithParameters party2 = new PartyWithParameters(
+				new PartyRef("party2"), new Parameters());
+
+		PartyWithProfile partyprofile1 = new PartyWithProfile(party1,
+				new ProfileRef("file:src/test/resources/profile1.json"));
+		PartyWithProfile partyprofile2 = new PartyWithProfile(party2,
+				new ProfileRef("file:src/test/resources/profile2.json"));
+
+		Map<String, Value> issuevalues1 = new HashMap<>();
+		issuevalues1.put(ISSUE1, new DiscreteValue("3500"));
+		issuevalues1.put(ISSUE2, new DiscreteValue("0.8"));
+		Bid bid1 = new Bid(issuevalues1);
+		Agreements agreement1 = new Agreements().with(new Agreements(bid1,
+				new HashSet<>(Arrays.asList(PARTY1, PARTY2))));
+
+		// different order but that shouldn't matter
+		Map<String, Value> issuevalues2 = new HashMap<>();
+		issuevalues2.put(ISSUE1, new DiscreteValue("3500"));
+		issuevalues2.put(ISSUE2, new DiscreteValue("0.8"));
+		Bid bid2 = new Bid(issuevalues2);
+		Agreements agreement2 = new Agreements().with(new Agreements(bid2,
+				new HashSet<>(Arrays.asList(PARTY1, PARTY3))));
+
+		Map<PartyId, PartyWithProfile> partiesmap = new HashMap<>();
+		partiesmap.put(PARTY1, partyprofile1);
+		partiesmap.put(PARTY2, partyprofile2);
+
+		Map<PartyId, PartyWithProfile> partiesmap2 = new HashMap<>();
+		partiesmap2.put(PARTY1, partyprofile2);
+		partiesmap2.put(PARTY3, partyprofile1);
+
+		result1 = new SessionResult(partiesmap, agreement1, penalties, null);
+		result2 = new SessionResult(partiesmap, agreement2, penalties, null);
+		result3 = new SessionResult(partiesmap, new Agreements(), penalties,
+				null);
+
+		HashMap<PartyId, BigDecimal> utils1 = new HashMap<>();
+		utils1.put(PARTY1, new BigDecimal("0.8"));
+		utils1.put(PARTY2, new BigDecimal("0.7"));
+		utils1.put(PARTY3, new BigDecimal("0.4"));
+		HashMap<PartyId, BigDecimal> utils2 = new HashMap<>();
+		utils2.put(PARTY1, new BigDecimal("0.8"));
+		utils2.put(PARTY2, new BigDecimal("0.9"));
+		utils2.put(PARTY3, new BigDecimal("0.4"));
+
+		reswithutil1 = new SessionResultWithUtils(partiesmap, agreement1,
+				penalties, null, utils1);
+		reswithutil1a = new SessionResultWithUtils(partiesmap, agreement1,
+				penalties, null, utils1);
+		reswithutil2 = new SessionResultWithUtils(partiesmap, agreement1,
+				penalties, null, utils2);
+
+	}
+
+	@Override
+	public List<List<SessionResultWithUtils>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(reswithutil1, reswithutil1a),
+				Arrays.asList(reswithutil2));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(
+				"SessionResultWithUtils.*party2=0.7, party1=0.8, party3=0.4.*",
+				"SessionResultWithUtils.*party2=0.9, party1=0.8, party3=0.4.*");
+	}
+
+	@Test
+	public void serializeTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(reswithutil1));
+		assertEquals(jsonstring, jackson.writeValueAsString(reswithutil1));
+	}
+
+	@Test
+	public void deserializeTest() throws IOException {
+		SessionResultWithUtils act = jackson.readValue(jsonstring,
+				SessionResultWithUtils.class);
+		assertEquals(reswithutil1, act);
+	}
+
+	@Test
+	public void createTest() {
+		TestReporter reporter = new TestReporter();
+		SessionResultWithUtils res = SessionResultWithUtils.create(result1,
+				reporter);
+		System.out.println(res);
+		assertEquals(null, reporter.getError());
+		assertEquals(new BigDecimal("0.5590"), // 0.56 - 0.001
+				res.getUtilities().get(PARTY1));
+		assertEquals(new BigDecimal("0.448"), // 0.45 - 0.002
+				res.getUtilities().get(PARTY2));
+
+	}
+
+	@Test
+	public void createNoAgreementTest() {
+		TestReporter reporter = new TestReporter();
+		SessionResultWithUtils res = SessionResultWithUtils.create(result3,
+				reporter);
+		System.out.println(res);
+		assertEquals(null, reporter.getError());
+		assertEquals(new BigDecimal("0.5600"), // "salary": "3500","fte": "0.8"
+				res.getUtilities().get(PARTY1));
+		assertEquals(new BigDecimal("0.50"), // "salary": "3000", "fte": "0.8"
+				res.getUtilities().get(PARTY2));
+
+	}
+
+	@Test
+	public void blaTest() {
+		// and if there is no resbid, is util=0?
+
+	}
+
+}
Index: /logconverter/src/test/java/geniusweb/logconverter/TestReporter.java
===================================================================
--- /logconverter/src/test/java/geniusweb/logconverter/TestReporter.java	(revision 48)
+++ /logconverter/src/test/java/geniusweb/logconverter/TestReporter.java	(revision 48)
@@ -0,0 +1,36 @@
+package geniusweb.logconverter;
+
+import java.util.logging.Level;
+
+import tudelft.utilities.logging.Reporter;
+
+/**
+ * Stores any reported errors and warnings so that we can test nothing bad
+ * happened
+ */
+public class TestReporter implements Reporter {
+	private String error = null;
+
+	@Override
+	public void log(Level level, String msg) {
+		log(level, msg, null);
+	}
+
+	@Override
+	public void log(Level level, String msg, Throwable thrown) {
+		System.out.println("" + level + ":" + msg);
+		if ((level == Level.SEVERE || level == Level.WARNING)
+				&& error == null) {
+			error = msg;
+		}
+	}
+
+	/**
+	 * 
+	 * @return error, or null if no error occured
+	 */
+	public String getError() {
+		return error;
+	}
+
+}
Index: /protocol/src/main/java/geniusweb/protocol/NegoState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/NegoState.java	(revision 47)
+++ /protocol/src/main/java/geniusweb/protocol/NegoState.java	(revision 48)
@@ -1,3 +1,5 @@
 package geniusweb.protocol;
+
+import java.util.List;
 
 import com.fasterxml.jackson.annotation.JsonAutoDetect;
@@ -7,4 +9,5 @@
 import com.fasterxml.jackson.annotation.JsonTypeInfo;
 
+import geniusweb.protocol.session.SessionResult;
 import geniusweb.protocol.session.SessionState;
 import geniusweb.protocol.tournament.TournamentState;
@@ -40,3 +43,10 @@
 	boolean isFinal(long currentTimeMs);
 
+	/**
+	 * 
+	 * @return List of the{@link SessionResult}s. Each SessionResult is a short
+	 *         report of the final outcome. Assumes {@link #isFinal(long)}.
+	 *         result may be undefined if not.
+	 */
+	List<SessionResult> getResults();
 }
Index: /protocol/src/main/java/geniusweb/protocol/session/SessionResult.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/SessionResult.java	(revision 47)
+++ /protocol/src/main/java/geniusweb/protocol/session/SessionResult.java	(revision 48)
@@ -34,6 +34,10 @@
 	 *                     be null. Some of them may have entered later of left
 	 *                     early. This list should contain them all.
-	 * @param agreements   the final Agreements.
-	 * @param penalties    the penalties in [0,1] for each participant.
+	 * @param agreements   the final Agreements. The key is the party ID, value
+	 *                     is the bid that the party agreed on. Only parties
+	 *                     that reached an agreement are in this list.
+	 * @param penalties    Key is the party ID, the value is the penalties in
+	 *                     [0,1] for that participant. A penalty only applies to
+	 *                     an agreement, not to a reservation bid.
 	 * @param error        a fatal error that terminated the session. Non-fatal
 	 *                     errors (warnings) are not to be reported. Null if no
Index: /protocol/src/main/java/geniusweb/protocol/session/SessionState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/SessionState.java	(revision 47)
+++ /protocol/src/main/java/geniusweb/protocol/session/SessionState.java	(revision 48)
@@ -65,10 +65,3 @@
 	Agreements getAgreements();
 
-	/**
-	 * 
-	 * @return the {@link SessionResult} which is a short report of the final
-	 *         outcome. Assumes {@link #isFinal(long)}. result may be undefined
-	 *         if not.
-	 */
-	SessionResult getResult();
 }
Index: /protocol/src/main/java/geniusweb/protocol/session/amop/AMOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/amop/AMOPState.java	(revision 47)
+++ /protocol/src/main/java/geniusweb/protocol/session/amop/AMOPState.java	(revision 48)
@@ -1,4 +1,5 @@
 package geniusweb.protocol.session.amop;
 
+import java.util.Arrays;
 import java.util.Collections;
 import java.util.Comparator;
@@ -251,7 +252,7 @@
 
 	@Override
-	public SessionResult getResult() {
-		return new SessionResult(partyprofiles, getAgreements(),
-				Collections.emptyMap(), null);
+	public List<SessionResult> getResults() {
+		return Arrays.asList(new SessionResult(partyprofiles, getAgreements(),
+				Collections.emptyMap(), null));
 	}
 
Index: /protocol/src/main/java/geniusweb/protocol/session/learn/LearnState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/learn/LearnState.java	(revision 47)
+++ /protocol/src/main/java/geniusweb/protocol/session/learn/LearnState.java	(revision 48)
@@ -1,4 +1,5 @@
 package geniusweb.protocol.session.learn;
 
+import java.util.Arrays;
 import java.util.Collections;
 import java.util.List;
@@ -68,7 +69,7 @@
 
 	@Override
-	public SessionResult getResult() {
-		return new SessionResult(getPartyProfiles(), getAgreements(),
-				Collections.emptyMap(), null);
+	public List<SessionResult> getResults() {
+		return Arrays.asList(new SessionResult(getPartyProfiles(),
+				getAgreements(), Collections.emptyMap(), null));
 	}
 
Index: /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPACState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPACState.java	(revision 47)
+++ /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPACState.java	(revision 48)
@@ -151,7 +151,7 @@
 
 	@Override
-	public SessionResult getResult() {
-		return new SessionResult(partyprofiles, getAgreements(),
-				Collections.emptyMap(), null);
+	public List<SessionResult> getResults() {
+		return Arrays.asList(new SessionResult(partyprofiles, getAgreements(),
+				Collections.emptyMap(), null));
 	}
 
Index: /protocol/src/main/java/geniusweb/protocol/session/mopac2/MOPAC2State.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/mopac2/MOPAC2State.java	(revision 47)
+++ /protocol/src/main/java/geniusweb/protocol/session/mopac2/MOPAC2State.java	(revision 48)
@@ -151,7 +151,7 @@
 
 	@Override
-	public SessionResult getResult() {
-		return new SessionResult(partyprofiles, getAgreements(),
-				Collections.emptyMap(), null);
+	public List<SessionResult> getResults() {
+		return Arrays.asList(new SessionResult(partyprofiles, getAgreements(),
+				Collections.emptyMap(), null));
 	}
 
Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 47)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 48)
@@ -1,4 +1,5 @@
 package geniusweb.protocol.session.saop;
 
+import java.util.Arrays;
 import java.util.Collections;
 import java.util.HashSet;
@@ -191,7 +192,7 @@
 
 	@Override
-	public SessionResult getResult() {
-		return new SessionResult(getPartyProfiles(), getAgreements(),
-				Collections.emptyMap(), getError());
+	public List<SessionResult> getResults() {
+		return Arrays.asList(new SessionResult(getPartyProfiles(),
+				getAgreements(), Collections.emptyMap(), getError()));
 	}
 
